#!/bin/bash

# Slackware build script for palemoon-bin

# Copyright 2015 pomfland
# Copyright 2017-2018 Skaendo <skaendo at excite dot com>
# Copyright 2018,2022 Vasily Sora USA
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
# permitted provided that the following conditions are met:
#
# 1. Redistributions of this script must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
#  THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
#  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO
#  EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
#  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
#  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
#  OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
#  ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cd $(dirname $0) ; CWD=$(pwd)

PRGNAM=palemoon-bin
SRCNAM=palemoon
VERSION=${VERSION:-34.0.1}
BUILD=${BUILD:-1}
TAG=${TAG:-_SBo}
PKGTYPE=${PKGTYPE:-tgz}

if [ -z "$ARCH" ]; then
case "$( uname -m )" in
    i?86) ARCH=i686 ;;
    arm*) ARCH=arm ;;
    *) ARCH=$( uname -m ) ;;
esac
fi

# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
# the name of the created package would be, and then exit. This information
# could be useful to other scripts.
if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
  echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
  exit 0
fi

TMP=${TMP:-/tmp/SBo}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}

GTK=${GTK:-gtk2}

# We don't need cflags since nothing is being compiled here.
# We do need to check the architecture though and abort when it's not
# supported.
if [ "$ARCH" = "i686" ]; then
  # Check for sse2 flag and abort if not found
  if ! grep -q sse2 /proc/cpuinfo; then
    echo "No required SSE2 support detected. Aborting."
    exit 1
  fi
elif [ "$ARCH" != "x86_64" ]; then
  echo "Sorry, binary packages are available only for i686 and x86_64. Aborting."
  exit 1
fi

set -e

rm -rf $PKG
mkdir -p $TMP $PKG $OUTPUT
cd $TMP
rm -rf $SRCNAM
tar xvf $CWD/$SRCNAM-$VERSION.linux-$ARCH-$GTK.tar.xz
cd $SRCNAM
chown -R root:root .
find -L . \
 \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
  -o -perm 511 \) -exec chmod 755 {} \; -o \
 \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
  -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;

# Use system hunspell if user wants it
if [ "$USE_SYSTEM_SPELLCHECK" = "yes" ]; then
  rm -rf dictionaries
  ln -sv /usr/share/hunspell dictionaries
fi

# Install pale moon into /opt
mkdir -p $PKG/opt/$PRGNAM
cp -vr * $PKG/opt/$PRGNAM

# Link stuff
## binary
mkdir -p $PKG/usr/bin
ln -s /opt/$PRGNAM/$PRGNAM $PKG/usr/bin/$PRGNAM
## icons
mkdir -p $PKG/usr/share/icons/hicolor/{16x16,32x32,48x48,128x128}/apps
ln -s /opt/$PRGNAM/browser/chrome/icons/default/default16.png \
  $PKG/usr/share/icons/hicolor/16x16/apps/$PRGNAM.png
ln -s /opt/$PRGNAM/browser/chrome/icons/default/default32.png \
  $PKG/usr/share/icons/hicolor/32x32/apps/$PRGNAM.png
ln -s /opt/$PRGNAM/browser/chrome/icons/default/default48.png \
  $PKG/usr/share/icons/hicolor/48x48/apps/$PRGNAM.png
ln -s /opt/$PRGNAM/browser/icons/mozicon128.png \
  $PKG/usr/share/icons/hicolor/128x128/apps/$PRGNAM.png

# Install .desktop file
mkdir -p $PKG/usr/share/applications
cp $CWD/$PRGNAM.desktop $PKG/usr/share/applications

find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
| cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true

mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild

mkdir -p $PKG/install
cat $CWD/slack-desc > $PKG/install/slack-desc
cat $CWD/doinst.sh > $PKG/install/doinst.sh

cd $PKG
/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
